// Coincides with 10.41
package main

import (
	migration "bitbucket.org/prmunty/util/dbmigration/db"
	"database/sql"
	_ "github.com/mattn/go-sqlite3"
	"log"
)

func main() {

	log.Println("starting...")

	const version float64 = 10.0

	migration.Migrate(version, func(tx *sql.Tx) (err error) {
		return migration.DoUntilErr(tx,
			AddUniqueIDTable,
			InsertFreezeData,
		)
	})
}

func AddUniqueIDTable(tx *sql.Tx) error {

	if _, err := tx.Exec(
		`DROP TABLE IF EXISTS uniqueID; CREATE TABLE uniqueID(id Text)`,
	); err != nil {
		return err
	}
	_, err := tx.Exec(`INSERT INTO "uniqueID" ("id") VALUES (?);`, "")
    if err != nil {
        return err
    }
	return nil
}

func InsertFreezeData(tx *sql.Tx) error {
	freezeIds := map[int]int {
        3368:60,
        372:61,
    }

	for zone := 0; zone < 30; zone++ {
		for key, value := range freezeIds {
			table_id := 0

			if _, err := tx.Exec(
				"INSERT INTO \"freeze_data_evap\" (\"freeze_id\",\"table_id\",\"zone\",\"selected\",\"ordinal\") VALUES(?, ?, ?, ?, ?);",
				key,
				table_id,
				zone,
				0,
				value,
			); err != nil {
				return err
			}
		}
	}

	return nil
}
