/*global $ getProduct sendRequest longWaitText Panel cancelButton okButton displayStatusModal areYouSureTitle suspendControls */
$(document).ready(function() {
    $("#submit-product").on('click', function() {
        var product = getProduct();
        var oldip = $("#old-ip").val();
        var oldport = $("#old-port").val();
        if (oldport != product.port ||  oldip != product.ip) {
            displayStatusModal({
                title: areYouSureTitle,
                body: suspendControls,
                footer: $("<span/>").append($(cancelButton), $(okButton)),
                onShow: function(e) {
                    $(okButton).on("click", function() {
                        $("#status-modal").modal('hide');
                        editProduct(product, oldip);
                    });
                }
            });
            return;
        }
        editProduct(product, oldip);




    });
});

function editProduct(product, oldip) {
    sendRequest(product, {
        method: "PUT",
        waitText: longWaitText,
        url: "/config/equipment/" + oldip,
        success: function(responseData, status, jqXHR) {
            if(remoteHB) {
              remoteHB.changeStart();
            }

            isServerUP(responseData.newaddress, product, oldip);
        },
        complete: function() {
            // Cancel default hide loading function
        }
    });
}


function isServerUP(address, product, oldIP) {
    window.setTimeout(function() {
        new Panel({
            url: "http://"+address+"/whoami",
            success: function () {
                 if ((window.location.hostname.includes(oldIP)
                      || window.location.hostname == product.url)){

                    if(remoteHB) {
                      remoteHB.changeHost(oldIP, address);
                      remoteHB.changeEnd();
                    }

                    window.location = "http://" + address + "/";
                } else {
                    if(remoteHB) {
                      remoteHB.changeHost(oldIP, address);
                      remoteHB.changeEnd();
                    }

                    window.location = "/config/equipment/";
                }

            },
            error: function () {
                if ((window.location.hostname.includes(oldIP)
                      || window.location.hostname == product.url)) {

                    if(remoteHB) {
                      remoteHB.changeEnd();
                    }

                    window.location = "/";
                } else {

                    if(remoteHB) {
                      remoteHB.changeEnd();
                    }

                    window.location = "/config/equipment/";
                }

            },
            numAttempts: 35,
            consecutiveSuccesses: 1,
            waitPeriod: 1000
        }).get();
    });
}
