/*global $ areYouSureTitle disconnectNetworkText noButton yesButton displayStatusModal sendRequest Panel
longWaitText displayError cancelText showLoading hideLoading*/
$(document).ready(function() {
    $("#submit-network").on('click', function() {
        var data =  {
            gateway: getGatewayIP(),
            mask: getMaskIP()
        };

        displayStatusModal({
            title: areYouSureTitle,
            body: disconnectNetworkText,
            footer: $("<span/>").append($(noButton)).append($(yesButton))

        });

        $(yesButton).on('click', function() {
            sendRequest(data,{
                waitText: longWaitText,
                url: "/config/equipment/network",
                success: function (responseData, status, jqXHR) {
                    if(remoteHB) {
                      remoteHB.changeStart();
                    }
                    isServerUp(responseData.newaddress, data);
                },
                complete: function(){}
            });
        });
    });

    $("#submit-dns").on('click', function() {
        var data =  {
            dns1: getPrimaryDNS(),
            dns2: getSecondaryDNS()
        };

        displayStatusModal({
            title: areYouSureTitle,
            body: submitChangesNote,
            footer: $("<span/>").append($(cancelButton)).append($(submitButton))
        });

        $(submitButton).on('click', function() {


            sendRequest(data,{
                waitText: longWaitText,
                url: "/config/equipment/dns",
                success: function (responseData, status, jqXHR) {
                    window.location = "/"
                },
                complete: function(){

                }
            });
        });
    });


    $("#auto-detect").on('click', function() {
        var container = $("<div>").addClass("content-row align-center loading-button-container");
        var button = $("<button>").attr("id", "cancel-button").addClass("button btn button-red bordered").append(cancelText);
        container.append(button);
        showLoading(longWaitText, container);

        $.ajax({
            url: "/config/network/auto/detect",
            success: function(data, statusText, jqXHR) {
                populateNetworking(data);

            },
            error: function() {
                displayError();
            },
            complete: function() {
                hideLoading();
            }
        });
    });
});

function getGatewayIP() {
    return getIP("gateway-octet-");
}

function getMaskIP() {
    return getIP("mask-octet-");
}

function getPrimaryDNS(){

    return getIP("dns1-octet-");
}

function getSecondaryDNS(){

    return getIP("dns2-octet-");
}

function getIP(idPrefix) {
    var ips = [];
    for (var x = 0; x <= 3; x++) {
        var val = $("#"+idPrefix+x).val();
        ips.push(val);
    }

    return ips.join(".");
}



function populateNetworking(data) {
    if (data.gateway) {
        populateIP("gateway-octet-", data.gateway);
    }

    if (data.mask) {
        populateIP("mask-octet-", data.mask);
    }
}

function populateIP(idPrefix, ip) {
    var octets = ip.split(".");
    for (var x in octets) {
        $("#"+idPrefix+x).val(octets[x]);
    }
}




function isServerUp(address) {
    window.setTimeout(function() {
        new Panel({
            url: "http://"+address+"/whoami",
            success: function () {
                if(remoteHB) {
                  remoteHB.changeHost(oldIP, address);
                  remoteHB.changeEnd();
                }

                window.location = "http://" + address + "/";
            },
            error: function () {
                if(remoteHB) {
                  remoteHB.changeEnd();
                }

                window.location = "/";
            },
            numAttempts: 65,
            consecutiveSuccesses: 34,
            waitPeriod: 1000
        }).get();
    });
}
